﻿using UnityEngine;
using System.Collections;

public class Player : MonoBehaviour {

	private Rigidbody2D myRigidbody;
	Animator animator;
	int health;
	[SerializeField]
	private float xspeed = 0;
	[SerializeField]
	private float yspeed = 0;
	private bool facingRight;
	private bool facingDown;


	// Use this for initialization
	void Start () {
		facingRight = true;
		myRigidbody = GetComponent<Rigidbody2D>();
		animator = GetComponent<Animator>();
	}

	// Update is called once per frame
	void Update ()
	{
		float horizontal = Input.GetAxis("Horizontal");
		float vertical = Input.GetAxis("Vertical");
		if (horizontal != 0) 
		{
			xspeed = horizontal;
			yspeed = 0;
			animator.SetBool ("Side", true);
			animator.SetBool ("Up", false);
			animator.SetBool ("Down", false);
		}
		if(vertical != 0)
		{
			xspeed = 0;
			yspeed = vertical;
			if (vertical < 0) {
				animator.SetBool ("Down", true);
				animator.SetBool ("Up", false);
				animator.SetBool ("Side", false);
			} else {
				animator.SetBool ("Up", true);
				animator.SetBool ("Down", false);
				animator.SetBool ("Side", false);
			}
		}
		HandleMovement();
		Flip(horizontal, vertical);

	}
	private void HandleMovement()
	{
		myRigidbody.velocity = new Vector2(xspeed, yspeed); // x == -1, y = 0;
	}

	private void Flip(float horizontal, float vertical)
	{
		if (horizontal > 0 && !facingRight || horizontal < 0 && facingRight) {
			facingRight = !facingRight;

			Vector3 theScale = transform.localScale;
			theScale.x *= -1;

			transform.localScale = theScale;
		} 
	}
	private void OnTriggerEnter2D (Collider2D other)
	{
	}
}
