﻿using UnityEngine;
using System;
using System.Collections.Generic;       //Allows us to use Lists.
using Random = UnityEngine.Random;

namespace Completed
{

	public class BoardManager : MonoBehaviour
	{

	    public GameObject YOU_WIN;
		public int columns;                                         //Number of columns in our game board.
		public int rows;                                            //Number of rows in our game board.
		//public GameObject[] floorTiles;                                 //Array of floor prefabs.
		//public GameObject[] outerWallTiles;                             //Array of outer tile prefabs.
		public GameObject[] character;
		public GameObject[] items;
		public GameObject tile;

		private Transform boardHolder;                                 		 		 //A variable to store a reference to the transform of our Board object.
		public List <GameObject> tilePositions = new List <GameObject> ();   	 	 //A list of possible locations to place items and enemies.
		public List <TerrainGeneration> tileScripts = new List <TerrainGeneration> ();
		//private List <GameObject> gridPositionsFloor = new List <GameObject> ();   //A list of possible locations to place tiles.

		public List <GameObject> lightenedTiles = new List <GameObject> ();													//track players progress
		public GameObject player;

		//Clears our list gridPositions and prepares it to generate a new board.
		void InitialiseList (List <GameObject> grid)
		{
			boardHolder = new GameObject ("Board").transform;
			//Clear our list gridPositions.
			grid.Clear ();

			//Loop through x axis (columns).
			for(int x = 1; x < columns-1; x++)
			{
				//Within each column, loop through y axis (rows).
				for(int y = 1; y < rows-1; y++)
				{
					//At each index add a new Vector3 to our list with the x and y coordinates of that position.
					GameObject instance = Instantiate (tile, new Vector3 (x, y, 0f), Quaternion.identity) as GameObject;
					grid.Add (instance);
					instance.transform.SetParent (boardHolder);
					tileScripts.Add (instance.GetComponent<TerrainGeneration> ());
				}
			}
			Debug.Log (tileScripts.Count + " Length of tileScripts after Initialise List \n");
		}

		//makes sure the player isn't near the border for the spawn
		int RandomPlayerPosition(){
			int rando = Random.Range (800, 12000);
			if (rando % 80 < 69 && rando % 80 > 10)
				return rando;
			else
				return RandomPlayerPosition ();

		}

		//RandomPosition returns a random position from our list gridPositions.
		Vector3 RandomPosition ()
		{
			//Declare an integer randomIndex, set it's value to a random number between 0 and the count of items in our List gridPositions.
			int randomIndex = RandomPlayerPosition();

			//Declare a variable of type Vector3 called randomPosition, set it's value to the entry at randomIndex from our List gridPositions.
			Vector3 randomPosition = tilePositions[randomIndex].transform.position;

			//Remove the entry at randomIndex from the list so that it can't be re-used.
			tilePositions.RemoveAt (randomIndex);

			//Return the randomly selected Vector3 position.
			return randomPosition;
		}
	
		// Update is called once per frame
	    public void SetupScene()
	    {
	        InitialiseList(tilePositions);
	        Vector3 p = RandomPosition();
	        Debug.Log("Instantiating " + character[0].name + " at " + p);
	        player = Instantiate(character[0], p, Quaternion.identity) as GameObject;
	    }

	public void Update()
	{
	        if (lightenedTiles.Count >= tileScripts*.9f)
	        {
	            YOU_WIN.SetActive(true);
	        }
	}

}
