﻿using UnityEngine;
using System.Collections;


public class Lantern : EnemyBehaviour 
{

	private Animator animator;
	private EnemyAggression enyaggr;

	private float timer = 0.1f;
	void Update () 
	{
		enyaggr = GetComponentInChildren<EnemyAggression> ();
		animator = GetComponent<Animator> ();
		if (enyaggr.agg) 
		{
			if (0f < timer && timer < 0.5f) 
				Move ();
			
			if (timer >= 1f)
				timer = -1f;

			timer += Time.deltaTime;
		}
	}
	void Move(){
		float yDir = player.transform.position.y - transform.position.y;
		float xDir = player.transform.position.x - transform.position.x;

		if (Mathf.Abs (yDir) > Mathf.Abs (xDir)) 
		{
			if (yDir > 0) 
			{
				animator.Play ("LanternUp");
				transform.position = new Vector2 (transform.position.x, transform.position.y + speed);
			} 
			else if (yDir < 0) 
			{
				animator.Play ("LanternDown");
				transform.position = new Vector2 (transform.position.x, transform.position.y - speed);
			}
		} 
		else 
		{
			if (xDir == 0 && yDir == 0) {
				transform.position = new Vector2 (transform.position.x, transform.position.y);
			}
			if (xDir < 0) 
			{
				animator.Play ("LanternLeft");
				transform.position = new Vector2 (transform.position.x - speed, transform.position.y);
			} else if (xDir > 0) 
			{
				animator.Play ("LanternRight");
				transform.position = new Vector2 (transform.position.x - speed, transform.position.y);
			}

		} 
	}
	void OnTriggerEnter2D(Collider2D coll)
	{
		if (coll.gameObject.CompareTag ("Player")) 
		{
		}
	}
	void OnTriggerStay2D(Collider2D coll)
	{
		if (coll.gameObject.CompareTag ("Player")) 
		{
		}
	}
}