﻿using UnityEngine;
using System.Collections;


public class Post : EnemyBehaviour 
{
	public GameObject enemyWepPrefab;
	GameObject enemyWep;
	bool notThrown = true;
	float throwIt = 1;
	float timer = 0;
	Vector2 playerLoc;

	private Animator animator;
	private EnemyAggression enyaggr;

	void Update () 
	{
		enyaggr = GetComponentInChildren<EnemyAggression> ();
		animator = GetComponent<Animator> ();
		if (enyaggr.agg) 
		{
			if (timer > 0) 
			{
				timer -= Time.deltaTime;
			} 
			else 
			{
				ThrowWep ();
			}
			if (enemyWep != null) 
			{
				enemyWep.transform.position = Vector2.MoveTowards (enemyWep.transform.position, playerLoc, speed / 50);
				if ((Vector2)enemyWep.transform.position == playerLoc) 
				{
					Destroy (enemyWep);
				}
			}
		}
	}
	void ThrowWep()
	{
		
		float rot = 0;

		float yDir = player.transform.position.y - transform.position.y;
		float xDir = player.transform.position.x - transform.position.x;
		if (yDir == 0) {
			if (xDir > 0) {
				rot = 180;
			} else if (xDir < 0) {
				rot = 0;
			}Debug.Log ("yDir " + yDir);
		} else if (xDir == 0) {
			if (yDir > 0) {
				rot = -90;
			} else if (yDir < 0) {
				rot = 90;
			}Debug.Log ("xDir " + xDir);
		} else {
			rot = Mathf.Atan2 (yDir, xDir);
			rot = Mathf.Rad2Deg* (rot);
			Debug.Log ("yDir " + yDir + " xDir " + xDir + " rot " + rot);
		}

		enemyWep = (GameObject)Instantiate (enemyWepPrefab, transform.position, Quaternion.identity);
		enemyWep.transform.Rotate (new Vector3 (0, 0, rot));
		playerLoc = base.player.transform.position;
		enemyWep.transform.position = Vector2.MoveTowards(enemyWep.transform.position, playerLoc, speed/50);
		timer = 4;
	}
	void OnTriggerEnter2D(Collider2D coll)
	{
		if (coll.gameObject.CompareTag ("Player")) 
		{
		}
	}
	void OnTriggerStay2D(Collider2D coll)
	{
		if (coll.gameObject.CompareTag ("Player")) 
		{
		}
	}
}