﻿using UnityEngine;
using System.Collections;


public class Spider : EnemyBehaviour 
{

	private Animator animator;
	private EnemyAggression enyaggr;
	public GameObject enemyWepPrefab;
	GameObject enemyWep;
	private float timer = 0.1f;
	void Update () 
	{
		enyaggr = GetComponentInChildren<EnemyAggression> ();
		animator = GetComponent<Animator> ();
		if (enyaggr.agg) 
		{
			
			if (0f < timer && timer < 0.9f) 
				Move ();

			if (timer >= 1f) {
				timer = -1.2f;
				enemyWep = (GameObject)Instantiate (enemyWepPrefab, transform.position, Quaternion.identity);
			}

			timer += Time.deltaTime;
		}
	}
	void Move(){
		float yDir = player.transform.position.y - transform.position.y;
		float xDir = player.transform.position.x - transform.position.x;

		if (Mathf.Abs (yDir) > Mathf.Abs (xDir)) 
		{
			if (yDir > 0) 
			{
				animator.Play ("SpiderUp");
				transform.position = new Vector2 (transform.position.x, transform.position.y + speed);
			} 
			else if (yDir < 0) 
			{
				animator.Play ("SpiderDown");
				transform.position = new Vector2 (transform.position.x, transform.position.y - speed);
			}
		} 
		else 
		{
			if (xDir == 0 && yDir == 0) {
				transform.position = new Vector2 (transform.position.x, transform.position.y);
			}
			if (xDir < 0) 
			{
				animator.Play ("SpiderLeft");
				transform.position = new Vector2 (transform.position.x - speed, transform.position.y);
			} else if (xDir > 0) 
			{
				animator.Play ("SpiderRight");
				transform.position = new Vector2 (transform.position.x - speed, transform.position.y);
			}

		} 
	}
	void OnTriggerEnter2D(Collider2D coll)
	{
		if (coll.gameObject.CompareTag ("Player")) 
		{
		}
	}
	void OnTriggerStay2D(Collider2D coll)
	{
		if (coll.gameObject.CompareTag ("Player")) 
		{
		}
	}
}