﻿using UnityEngine;
using System.Collections;


public class Taint : EnemyBehaviour 
{

	private Animator animator;
	private EnemyAggression enyaggr;
	void Update () 
	{
		enyaggr = GetComponentInChildren<EnemyAggression> ();
		animator = GetComponent<Animator> ();
		if (enyaggr.agg) 
		{
			float yDir = player.transform.position.y - transform.position.y;
			float xDir = player.transform.position.x - transform.position.x;

			if (Mathf.Abs (yDir) > Mathf.Abs (xDir)) 
			{
				if (yDir > 0) 
				{
					animator.Play ("TaintUp");
					transform.position = new Vector2 (transform.position.x, transform.position.y + speed);
				} 
				else if (yDir < 0) 
				{
					animator.Play ("TaintDown");
					transform.position = new Vector2 (transform.position.x, transform.position.y - speed);
				}
			} 
			else 
			{
				if (xDir == 0 && yDir == 0) {
					transform.position = new Vector2 (transform.position.x, transform.position.y);
				}
				if (xDir < 0) 
				{
					animator.Play ("TaintLeft");
					transform.position = new Vector2 (transform.position.x - speed, transform.position.y);
				} else if (xDir > 0) 
				{
					animator.Play ("TaintRight");
					transform.position = new Vector2 (transform.position.x - speed, transform.position.y);
				}

			} 
		}

	}

	void OnTriggerEnter2D(Collider2D coll)
	{
		if (coll.gameObject.CompareTag ("Player")) 
		{
			//dodamage;
		}
	}
	void OnTriggerStay2D(Collider2D coll)
	{
		if (coll.gameObject.CompareTag ("Player")) 
		{
			//do continuous damage;
		}
	}
}
