﻿using UnityEngine;
using System;
using System.Collections.Generic;       //Allows us to use Lists.
using Random = UnityEngine.Random;

namespace Completed
{
	public class TerrainGeneration : MonoBehaviour 
	{
		public static int countTotal;
		public GameObject[] items;


		//stuff for generation
		public GameObject[] floorTiles;                                 //Array of floor prefabs.
		public GameObject[] enemyTiles;                                 //Array of enemy prefabs.
		public GameObject[] spookyTiles;
		public Vector3 tilePosition;
		public int enemySpawnRate = 99; 								//lower the int the more enemies spawn

		public bool generated;
		public int tileType;											//0,1,2, or 3 (-1 for null)

		public BoardManager boardScript;                       			//need rows and columns to determine if outer wall

		GameObject tile;
		GameObject spookTile;

		void OnTriggerStay2D(Collider2D other)
		{
			if (other.gameObject.CompareTag ("Field of View") && !generated) {

				//random chance of enemy spawning on the new tile, could also use the same statements for items
				if (Random.Range (1, 100) >= enemySpawnRate) {
					GameObject enemyChoice = enemyTiles[Random.Range(0, enemyTiles.Length - 1)];
					Instantiate (enemyChoice, tilePosition, Quaternion.identity);
				}

				if (Random.Range (1, 100) >= enemySpawnRate) {
					GameObject itemChoice = items[Random.Range(0, items.Length)];
					Instantiate (itemChoice, tilePosition, Quaternion.identity);
				}

				if (spookTile)
					Destroy (spookTile);

				//GameObject tileChoice = floorTiles [Random.Range (0, floorTiles.Length)]; //complete random
				//GameObject tileChoice = floorTiles[BiasedDecision(getNeighbors())]; //neigbor tile random
				GameObject tileChoice = floorTiles[PositionBiasedDecision()]; // location based random
				tile = Instantiate(tileChoice, tilePosition, Quaternion.identity) as GameObject;
				boardScript.lightenedTiles.Add(tile); //prog made, add the tile to the list of lightened tiles
				generated = true;
				Destroy (tile, 400f);
			}

		}

		int PositionBiasedDecision()
		{
			int index = (((int)tilePosition.x - 1) * 80 + (int)tilePosition.y - 1);
			if (index % 80 < 60 && index % 80 > 20) {
				if (index > 3200 && index < 9600) {
					//favor Grass and Stone
					int randomGen = Random.Range (1, 100);
					if (randomGen < 40)
						return 2;
					else if (randomGen >= 40 && randomGen < 80)
						return 3;
					else if (randomGen >= 80 && randomGen < 90)
						return 0;
					else
						return 1;

				} 
				else {
					int randomGen = Random.Range (1, 100);
					if (randomGen < 40)
						return 0;//water terrain
					else if (randomGen >= 40 && randomGen < 80)
						return 1;//dessert terrain
					else if (randomGen >= 80 && randomGen < 90)
						return 2;//grass terrain
					else
						return 3;//rock terrain
				}
				//favor Water and Dessert
			}
			else {
				int randomGen = Random.Range (1,100);
				if (randomGen < 40)
					return 0;
				else if (randomGen >= 40 && randomGen < 80)
					return 1;
				else if (randomGen >= 80 && randomGen < 90)
					return 2;
				else
					return 3;
			}
				//favor Water and Dessert
		}

		//needs to be given the floor types of neighboring tiles to work
		int BiasedDecision(int[] types)
		{
			//track total types given and eahc floor types total
			int total = 0;
			int[] typeTotals = new int[4]; //4 types of tiles

			//loop through all types given adding to the appropiate floor type total
			for (int x = 0; x < types.Length; x++) {
				if (types[x] == -1) {continue;}
				typeTotals[(int) (types[x])]++;
				total++; //increment total
			}

			int returnType = 0; //floor type to be returned
			float[] typeResults = new float[types.Length]; //save all biased random results
			for (int x = 0; x < typeTotals.Length; x++) {
				//highest randomly generated number is the winner and will be returned
				//Using my completely redundant and wasteful method you can be sure of nothing

				typeResults[x] = (float) (Random.Range (1, 200) * (typeTotals[x] / total + 3));
				if (typeResults [returnType] < typeResults [x])
					returnType = x;
			}

			return returnType;
		}

		// Use this for initialization
		void Start () {
			tilePosition = this.transform.position;
			generated = false;
			tileType = -1;
			GameObject gameBoard = GameObject.FindGameObjectWithTag ("Game Manager");
			boardScript = gameBoard.GetComponent<BoardManager> ();
		}

		int[] getNeighbors(){
			
			int[] floorTypeTotals = new int[8];
			int count = 0;
			Debug.Log("Tilescripts holds : " + boardScript.tileScripts.Count + "\n");
			Debug.Log("Grid holds : " + boardScript.tilePositions.Count + "\n");

			for (int x = (int) tilePosition.x - 1; x < (int) tilePosition.x + 2; x++) {
				for (int y = (int) tilePosition.y - 1; y < (int) tilePosition.y + 2; y++) {
					count++;
					if ((tilePosition.y == y && tilePosition.x == x) || x < 1 || y < 1 || x > 160 || y > 80)
						continue;
					int fuck = boardScript.tileScripts [((x - 1) * 80 + y) - 1].tileType;
					if (fuck < 0)
						continue;
					Debug.Log (fuck + "Type" );
					floorTypeTotals[boardScript.tileScripts [((x - 1) * 80 + y) - 1].tileType]++;
				}
			}
			Debug.Log("Tilescripts holds : " + boardScript.tileScripts.Count + "\n");

			return floorTypeTotals;
		}
		
		// Update is called once per frame
		void Update () {
			if (generated && tile == null) {
				generated = false;
				boardScript.lightenedTiles.Remove(tile);//prog lost
				if(tileType >= 0)
					spookTile = Instantiate (spookyTiles[tileType], tilePosition, Quaternion.identity) as GameObject;
				
			}
		}
	}
}
